<!DOCTYPE html>
<html lang="en">
<head>
  <link rel="icon" type="image/png" href="favicon.ico">
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <title>Taula Llista Total</title>

  <!-- Report viewer Office2013 style -->
  <link href="css/stimulsoft.viewer.office2013.whiteblue.css" rel="stylesheet">
  <!-- Stimusloft Reports.JS -->
  <script src="scripts/stimulsoft.reports.js" type="text/javascript"></script>
  <script src="scripts/stimulsoft.viewer.js" type="text/javascript"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <!-- Report viewer scripts, may be external -->
  <script type="text/javascript">

    Stimulsoft.Base.StiLicense.key = "6vJhGtLLLz2GNviWmUTrhSqnOItdDwjBylQzQcAOiHl9LZVQiBlQlK3LDbITbR7kOWF8A3pfruDxWDyh10PMkQ2uys" +
      "gCZppz88s5pi2F/rWtVNPKUZDEyp2ejsBnrKcC3anGUWDfOFXaFOgnOjQm1VDUYh3pacW4efiVHcVd0rwKp1uOGfcb" +
      "0WIjH4p/fzBuUnoHtRZaDExYrR83YgYOqdVQNLrDXvr+/79pXcg89tGWDYlqTfI1aWsp1BdwOIbInS2Fv06oZobDRX" +
      "wrhb+zdOSrEpto4X41BXFs/3D/gzdsQy4ijiF5Cmh8irGmzuxPnRsiB0kZa/eU7lnwxOSVMA2AIWDa4PZxB5kzZGze" +
      "b+aPWFegN/garYsnpd5Y5DOK3gSrh/KnvzT05cloXIxhS0ee3PGQMPWc8BlNNtkyi5Mfcu8elTeAFukZwyEw3r4AtP" +
      "GI84o2QGMgRTRftave9XzX21M8DPgtVFGWkPzkNglV7j5nCXHDDP7XpMuk6Pgj6w0uCdcgRIqulqBx6CpsZOkXedz4" +
      "bDinuB/hK4NsPPfjGolOZBGAzHJomaLdcHkl";

    var options = new Stimulsoft.Viewer.StiViewerOptions();
    options.toolbar.viewMode = Stimulsoft.Viewer.StiWebViewMode.Continuous;
    options.toolbar.showResourcesButton = false;



    /*var settingsExcel = new Stimulsoft.Report.Export.StiExcelExportSettings();
    settingsExcel.dataExportMode = Stimulsoft.Report.Export.StiDataExportMode.DataAndHeaders;
    console.log(settingsExcel);*/

    // Create Viewer component.
    var viewer = new Stimulsoft.Viewer.StiViewer(options, "StiViewer", true);

    var report = new Stimulsoft.Report.StiReport();

    function onLoadPage(){

      var jsonData = JSON.parse(jsonString.value);

      var dataSet = new Stimulsoft.System.Data.DataSet();
      dataSet.readJson(jsonData);
      var data = dataSet.tables.getByIndex(0);

      //Add data to datastore
      report.regData("data", "data", dataSet);

      //Fill dictionary
      var dataSource = new Stimulsoft.Report.Dictionary.StiDataTableSource(data.tableName, data.tableName, data.tableName);
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("num_activitat", "num_activitat", "num_activitat"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("nom_activitat", "nom_activitat", "nom_activitat"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("mod_activitat", "mod_activitat", "mod_activitat"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("hores", "hores", "hores"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("data_activitat", "data_activitat", "data_activitat"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("dni", "dni", "dni"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("nom_persona", "nom_persona", "nom_persona"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("adreca_persona", "adreca_persona", "adreca_persona"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("poblacio_persona", "poblacio_persona", "poblacio_persona"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("cp_persona", "cp_persona", "cp_persona"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("telefon_persona", "telefon_persona", "telefon_persona"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("mobil_persona", "mobil_persona", "mobil_persona"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("email", "email", "email"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("sexe", "sexe", "sexe"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("nacionalitat", "nacionalitat", "nacionalitat"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("categoria", "categoria", "categoria"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("dedicacio", "dedicacio", "dedicacio"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("data_persona", "data_persona", "data_persona"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("area", "area", "area"));
      dataSource.columns.add(new Stimulsoft.Report.Dictionary.StiDataColumn("doctor", "doctor", "doctor"));
      report.dictionary.dataSources.add(dataSource);

      var page = report.pages.getByIndex(0);

      //Create HeaderBand
      var headerBand = new Stimulsoft.Report.Components.StiHeaderBand();
      headerBand.height = 1;
      headerBand.name = "HeaderBand";
      page.components.add(headerBand);

      //Create Databand
      var dataBand = new Stimulsoft.Report.Components.StiDataBand();
      dataBand.dataSourceName = data.tableName;
      dataBand.height = 1;
      dataBand.name = "DataBand"
      page.components.add(dataBand);

      //Create texts
      var pos = 0;

      var columnWidth = Stimulsoft.Base.StiAlignValue.alignToMinGrid(page.width / data.columns.count, 0.5, true);

      var nameIndex = 1;

      for (var index in data.columns.list)
      {
        var dataColumn = data.columns.list[index];
        //Create text on header
        var headerText = new Stimulsoft.Report.Components.StiText();
        headerText.clientRectangle = new Stimulsoft.System.Drawing.Rectangle(pos, 1.5, columnWidth*2.85, 1);
        headerText.text = dataColumn.caption;
        headerText.horAlignment = Stimulsoft.Base.Drawing.StiTextHorAlignment.Center;
        headerText.vertAlignment = Stimulsoft.Base.Drawing.StiVertAlignment.Center;
        headerText.border.side = Stimulsoft.Base.Drawing.StiBorderSides.All;
        headerText.name = "HeaderText" + nameIndex.toString();
        headerText.brush = new Stimulsoft.Base.Drawing.StiSolidBrush(Stimulsoft.System.Drawing.Color.cornflowerBlue);
        headerBand.components.add(headerText);

        //Create text on Data Band
        var dataText = new Stimulsoft.Report.Components.StiText();
        dataText.clientRectangle = new Stimulsoft.System.Drawing.Rectangle(pos, 0, columnWidth*2.85, 1);
        dataText.wordWrap = true;
        dataText.text = Stimulsoft.System.StiString.format("{{0}.{1}}", data.tableName, dataColumn.columnName);
        dataText.horAlignment = Stimulsoft.Base.Drawing.StiTextHorAlignment.Center;
        dataText.vertAlignment = Stimulsoft.Base.Drawing.StiVertAlignment.Center;
        dataText.name = "DataText" + nameIndex.toString();
        dataText.border.side = Stimulsoft.Base.Drawing.StiBorderSides.All;

        //Add highlight
        var condition = new Stimulsoft.Report.Components.StiCondition();
        condition.backColor = Stimulsoft.System.Drawing.Color.lightSlateGray;
        condition.textColor = Stimulsoft.System.Drawing.Color.black;
        condition.expression = 'Table1.Info4 == "ACTIVITAT"';
        condition.item = Stimulsoft.Report.Components.StiFilterItem.Expression;

        dataBand.components.add(dataText);

        pos = pos + columnWidth*2.85;

        nameIndex++;
      }

      var databand = report.getComponentByName("DataBand");
      databand.conditions.add(condition);

      //Create FooterBand
      var footerBand = new Stimulsoft.Report.Components.StiFooterBand();
      footerBand.height = 0.5;
      footerBand.name = "FooterBand";
      page.components.add(footerBand);

      //Create text on footer
      var footerText = new Stimulsoft.Report.Components.StiText();
      footerText.clientRectangle = new Stimulsoft.System.Drawing.Rectangle(0, 0, page.width*1.501, 0.5);
      footerText.text = "Total de Registres: {Count()}";
      footerText.horAlignment = Stimulsoft.Base.Drawing.StiTextHorAlignment.Right;
      footerText.vertAlignment = Stimulsoft.Base.Drawing.StiVertAlignment.Center;
      footerText.name = "FooterText";
      footerText.border.side = Stimulsoft.Base.Drawing.StiBorderSides.All;
      footerText.brush = new Stimulsoft.Base.Drawing.StiSolidBrush(Stimulsoft.System.Drawing.Color.cornflowerBlue);
      footerBand.components.add(footerText);

      //Create text component
      var titleText = new Stimulsoft.Report.Components.StiText();
      titleText.clientRectangle = new Stimulsoft.System.Drawing.Rectangle(0, 0, page.width*1.50175, 1);
      titleText.wordWrap = true;
      titleText.text = "CURS: <?php echo $_GET["any"];?>";
      titleText.font = new Stimulsoft.System.Drawing.Font("Roboto-Black", 18);
      titleText.horAlignment = Stimulsoft.Base.Drawing.StiTextHorAlignment.Center;
      titleText.vertAlignment = Stimulsoft.Base.Drawing.StiVertAlignment.Center;

      page.components.add(titleText);

      report.pages.list[0].orientation = Stimulsoft.Report.Components.StiPageOrientation.Landscape;

      // Button Export Excel Mode
      var userButton = viewer.jsObject.SmallButton("userButton", "Export", "emptyImage");
      userButton.image.src = "https://www.stimulsoft.com/favicon.png";
      userButton.action = function () {
        report.renderAsync(function() {
          report.exportDocumentAsync(function (data) {
            let settings = new Stimulsoft.Report.Export.StiExcelExportSettings();
            let stream = new Stimulsoft.System.IO.MemoryStream();
            let service = new Stimulsoft.Report.Export.StiExcel2007ExportService();
            settings.dataExportMode = StiDataExportMode.DataAndHeadersFooters;
            alert(settings);
            StiOptions.Export.Excel.AllowExportDateTime = true;
            alert(StiOptions.Export.Excel);

            format = Stimulsoft.Report.StiExportFormat.Excel2007;
            mimeType = 'application/excel';
            extension = 'xlsx';
            console.log(settings.dataExportMode.toString());
            report.exportDocument(format, service, settings);
           // service.exportTo(report, stream, settings);
           // Stimulsoft.System.StiObject.saveAs(data, "llistaTotal."+extension);
          }, Stimulsoft.Report.StiExportFormat.Excel2007);
        });
      }

      var toolbarTable = viewer.jsObject.controls.toolbar.firstChild.firstChild;
      var buttonsTable = toolbarTable.rows[0].firstChild.firstChild;
      var userButtonCell = buttonsTable.rows[0].insertCell(0);
      userButtonCell.className = "stiJsViewerClearAllStyles";
      userButtonCell.appendChild(userButton);


      // export events
      viewer.onBeginExportReport = function (event)
      {
        switch (event.format)
        {
          case Stimulsoft.Report.StiExportFormat.Html: // exportando a HTML si funciona
            event.settings.zoom = 2; // Set zoom to 200%
            break;

          case Stimulsoft.Report.StiExportFormat.Excel: // no funciona
            event.settings.dataExportMode = "DataAndHeaders";
            alert(event);
            break;

          case Stimulsoft.Report.StiExportFormat.Pdf: // no funciona
            event.settings.allowEditable = true;
            break;
        }
      }


      // Export
      /*DA BIEN
      var prova = Stimulsoft.Report.Export.StiDataExportMode.DataAndHeaders;
      console.log(prova);
      */

      report.renderAsync(function ()
      {
        var settings = new Stimulsoft.Report.Export.StiExcelExportSettings();
        var stream = new Stimulsoft.System.IO.MemoryStream();
        var service = new Stimulsoft.Report.Export.StiExcel2007ExportService();
        settings.dataExportMode = 3;
        settings.exportDataOnly = false;
        settings.imageResolution = 200;
        console.log(settings.dataExportMode.toString());
        service.exportTo(report, stream, settings);
      });
      viewer.report = report;
    }

    function exportExcel() // tampoco funciona
    {
      report.renderAsync(function()
      {
        report.exportDocumentAsync(function (data)
        {
          let settings = new Stimulsoft.Report.Export.StiExcel2007ExportSettings();
          let stream = new Stimulsoft.System.IO.MemoryStream();
          let service = new Stimulsoft.Report.Export.StiExcel2007ExportService();

          format = Stimulsoft.Report.StiExportFormat.Excel2007;
          mimeType = 'application/excel';
          extension = 'xlsx';

          settings.dataExportMode = Stimulsoft.Report.Export.StiDataExportMode.DataAndHeaders;
          console.log(settings.dataExportMode.toString());
          service.exportTo(report, stream, settings);
          Stimulsoft.System.StiObject.saveAs(data, "prova."+extension);
        }, Stimulsoft.Report.StiExportFormat.Excel2007);
      });
    }

  </script>

</head>
<body onload="onLoadPage()">
<label for="jsonString"></label>
<textarea name="jsonString" id="jsonString" style="width: 100%; height: 100px; display: none">
  {
  "Table1" : [<?php $jsonString = file_get_contents("../temp/LlistaTotal.json"); echo $jsonString;?>]
  }
</textarea>
<div>
  <script type="text/javascript">
    // Show the report viewer in this place
    if(<?php echo $jsonString;?> == null || <?php echo $jsonString;?> == "")
    {
      var errorForm = viewer.jsObject.controls.forms.errorMessageForm || viewer.jsObject.InitializeErrorMessageForm();
      errorForm.show("Ho sentim però no hi han activitats en aquest curs");
    }
    else
    {
      viewer.renderHtml();
    }
  </script>
</div>
</body>
</html>
